package com.zanxiang.game.back.serve.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zanxiang.game.back.serve.dao.mapper.GameOceanengineOrderSplitLogMapper;
import com.zanxiang.game.back.serve.pojo.entity.GameOceanengineOrderSplitLog;
import com.zanxiang.game.back.serve.pojo.vo.GameOceanengineOrderSplitLogVO;
import com.zanxiang.game.back.serve.service.IGameOceanengineOrderSplitLogService;
import com.zanxiang.module.util.NumberUtil;
import com.zanxiang.module.util.bean.BeanUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

@Slf4j
@Service
public class GameOceanengineOrderSplitLogServiceImpl extends ServiceImpl<GameOceanengineOrderSplitLogMapper, GameOceanengineOrderSplitLog>
        implements IGameOceanengineOrderSplitLogService {

    @Override
    public List<GameOceanengineOrderSplitLogVO> listByOrderNo(Collection<String> orderNos) {
        if (CollectionUtils.isEmpty(orderNos)) {
            return Collections.emptyList();
        }
        return list(new LambdaQueryWrapper<GameOceanengineOrderSplitLog>()
                .in(GameOceanengineOrderSplitLog::getOrderNo, orderNos)
                .orderByAsc(GameOceanengineOrderSplitLog::getBackIndex)
        ).stream().map(this::toVOSimple).collect(Collectors.toList());
    }

    private GameOceanengineOrderSplitLogVO toVOSimple(GameOceanengineOrderSplitLog log) {
        if (log == null) {
            return null;
        }
        GameOceanengineOrderSplitLogVO vo = BeanUtil.copy(log, GameOceanengineOrderSplitLogVO.class);
        if (log.getSplitMoney() != null) {
            vo.setSplitMoney(NumberUtil.divide100(new BigDecimal(log.getSplitMoney())));
        }
        return vo;
    }
}
